// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.5.1
// - protoc             v4.25.6
// source: plugin_registry.proto

package gen

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.64.0 or later.
const _ = grpc.SupportPackageIsVersion9

const (
	PluginRegistry_GetPluginByID_FullMethodName              = "/martiancloud.phobos.api.pluginregistry.PluginRegistry/GetPluginByID"
	PluginRegistry_GetPlugins_FullMethodName                 = "/martiancloud.phobos.api.pluginregistry.PluginRegistry/GetPlugins"
	PluginRegistry_GetPluginVersionByID_FullMethodName       = "/martiancloud.phobos.api.pluginregistry.PluginRegistry/GetPluginVersionByID"
	PluginRegistry_GetPluginVersions_FullMethodName          = "/martiancloud.phobos.api.pluginregistry.PluginRegistry/GetPluginVersions"
	PluginRegistry_GetPluginPlatformByID_FullMethodName      = "/martiancloud.phobos.api.pluginregistry.PluginRegistry/GetPluginPlatformByID"
	PluginRegistry_GetPluginPlatforms_FullMethodName         = "/martiancloud.phobos.api.pluginregistry.PluginRegistry/GetPluginPlatforms"
	PluginRegistry_CreatePlugin_FullMethodName               = "/martiancloud.phobos.api.pluginregistry.PluginRegistry/CreatePlugin"
	PluginRegistry_CreatePluginVersion_FullMethodName        = "/martiancloud.phobos.api.pluginregistry.PluginRegistry/CreatePluginVersion"
	PluginRegistry_CreatePluginPlatform_FullMethodName       = "/martiancloud.phobos.api.pluginregistry.PluginRegistry/CreatePluginPlatform"
	PluginRegistry_UpdatePlugin_FullMethodName               = "/martiancloud.phobos.api.pluginregistry.PluginRegistry/UpdatePlugin"
	PluginRegistry_UploadPluginVersionDocFile_FullMethodName = "/martiancloud.phobos.api.pluginregistry.PluginRegistry/UploadPluginVersionDocFile"
	PluginRegistry_UploadPluginVersionReadme_FullMethodName  = "/martiancloud.phobos.api.pluginregistry.PluginRegistry/UploadPluginVersionReadme"
	PluginRegistry_UploadPluginVersionSchema_FullMethodName  = "/martiancloud.phobos.api.pluginregistry.PluginRegistry/UploadPluginVersionSchema"
	PluginRegistry_UploadPluginVersionShaSums_FullMethodName = "/martiancloud.phobos.api.pluginregistry.PluginRegistry/UploadPluginVersionShaSums"
	PluginRegistry_UploadPluginPlatformBinary_FullMethodName = "/martiancloud.phobos.api.pluginregistry.PluginRegistry/UploadPluginPlatformBinary"
	PluginRegistry_DeletePlugin_FullMethodName               = "/martiancloud.phobos.api.pluginregistry.PluginRegistry/DeletePlugin"
	PluginRegistry_DeletePluginVersion_FullMethodName        = "/martiancloud.phobos.api.pluginregistry.PluginRegistry/DeletePluginVersion"
	PluginRegistry_DeletePluginPlatform_FullMethodName       = "/martiancloud.phobos.api.pluginregistry.PluginRegistry/DeletePluginPlatform"
)

// PluginRegistryClient is the client API for PluginRegistry service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
//
// PluginRegistry is the service that provides methods to manage plugins.
type PluginRegistryClient interface {
	// GetPluginByID returns a plugin by its ID.
	GetPluginByID(ctx context.Context, in *GetPluginByIdRequest, opts ...grpc.CallOption) (*Plugin, error)
	// GetPlugins returns a paginated list of plugins.
	GetPlugins(ctx context.Context, in *GetPluginsRequest, opts ...grpc.CallOption) (*GetPluginsResponse, error)
	// GetPluginVersionByID returns a plugin version by its ID.
	GetPluginVersionByID(ctx context.Context, in *GetPluginVersionByIdRequest, opts ...grpc.CallOption) (*PluginVersion, error)
	// GetPluginVersions returns a list of plugin versions.
	GetPluginVersions(ctx context.Context, in *GetPluginVersionsRequest, opts ...grpc.CallOption) (*GetPluginVersionsResponse, error)
	// GetPluginPlatformByID returns a plugin platform by its ID.
	GetPluginPlatformByID(ctx context.Context, in *GetPluginPlatformByIdRequest, opts ...grpc.CallOption) (*PluginPlatform, error)
	// GetPluginPlatforms returns a list of plugin platforms.
	GetPluginPlatforms(ctx context.Context, in *GetPluginPlatformsRequest, opts ...grpc.CallOption) (*GetPluginPlatformsResponse, error)
	// CreatePlugin creates a new plugin.
	CreatePlugin(ctx context.Context, in *CreatePluginRequest, opts ...grpc.CallOption) (*Plugin, error)
	// CreatePluginVersion creates a new plugin version.
	CreatePluginVersion(ctx context.Context, in *CreatePluginVersionRequest, opts ...grpc.CallOption) (*PluginVersion, error)
	// CreatePluginPlatform creates a new plugin platform.
	CreatePluginPlatform(ctx context.Context, in *CreatePluginPlatformRequest, opts ...grpc.CallOption) (*PluginPlatform, error)
	// UpdatePlugin updates a plugin.
	UpdatePlugin(ctx context.Context, in *UpdatePluginRequest, opts ...grpc.CallOption) (*Plugin, error)
	UploadPluginVersionDocFile(ctx context.Context, opts ...grpc.CallOption) (grpc.ClientStreamingClient[UploadPluginVersionDocFileRequest, emptypb.Empty], error)
	// UploadPluginVersionReadme uploads a readme for a plugin version.
	UploadPluginVersionReadme(ctx context.Context, opts ...grpc.CallOption) (grpc.ClientStreamingClient[UploadPluginVersionReadmeRequest, emptypb.Empty], error)
	UploadPluginVersionSchema(ctx context.Context, opts ...grpc.CallOption) (grpc.ClientStreamingClient[UploadPluginVersionSchemaRequest, emptypb.Empty], error)
	// UploadPluginVersionShaSums uploads SHA sums for a plugin version.
	UploadPluginVersionShaSums(ctx context.Context, opts ...grpc.CallOption) (grpc.ClientStreamingClient[UploadPluginVersionShaSumsRequest, emptypb.Empty], error)
	// UploadPluginPlatformBinary uploads a plugin platform binary.
	UploadPluginPlatformBinary(ctx context.Context, opts ...grpc.CallOption) (grpc.ClientStreamingClient[UploadPluginPlatformBinaryRequest, emptypb.Empty], error)
	// DeletePlugin deletes a plugin.
	DeletePlugin(ctx context.Context, in *DeletePluginRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// DeletePluginVersion deletes a plugin version by its ID.
	DeletePluginVersion(ctx context.Context, in *DeletePluginVersionRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// DeletePluginPlatform deletes a plugin platform by its ID.
	DeletePluginPlatform(ctx context.Context, in *DeletePluginPlatformRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
}

type pluginRegistryClient struct {
	cc grpc.ClientConnInterface
}

func NewPluginRegistryClient(cc grpc.ClientConnInterface) PluginRegistryClient {
	return &pluginRegistryClient{cc}
}

func (c *pluginRegistryClient) GetPluginByID(ctx context.Context, in *GetPluginByIdRequest, opts ...grpc.CallOption) (*Plugin, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(Plugin)
	err := c.cc.Invoke(ctx, PluginRegistry_GetPluginByID_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pluginRegistryClient) GetPlugins(ctx context.Context, in *GetPluginsRequest, opts ...grpc.CallOption) (*GetPluginsResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(GetPluginsResponse)
	err := c.cc.Invoke(ctx, PluginRegistry_GetPlugins_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pluginRegistryClient) GetPluginVersionByID(ctx context.Context, in *GetPluginVersionByIdRequest, opts ...grpc.CallOption) (*PluginVersion, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(PluginVersion)
	err := c.cc.Invoke(ctx, PluginRegistry_GetPluginVersionByID_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pluginRegistryClient) GetPluginVersions(ctx context.Context, in *GetPluginVersionsRequest, opts ...grpc.CallOption) (*GetPluginVersionsResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(GetPluginVersionsResponse)
	err := c.cc.Invoke(ctx, PluginRegistry_GetPluginVersions_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pluginRegistryClient) GetPluginPlatformByID(ctx context.Context, in *GetPluginPlatformByIdRequest, opts ...grpc.CallOption) (*PluginPlatform, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(PluginPlatform)
	err := c.cc.Invoke(ctx, PluginRegistry_GetPluginPlatformByID_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pluginRegistryClient) GetPluginPlatforms(ctx context.Context, in *GetPluginPlatformsRequest, opts ...grpc.CallOption) (*GetPluginPlatformsResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(GetPluginPlatformsResponse)
	err := c.cc.Invoke(ctx, PluginRegistry_GetPluginPlatforms_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pluginRegistryClient) CreatePlugin(ctx context.Context, in *CreatePluginRequest, opts ...grpc.CallOption) (*Plugin, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(Plugin)
	err := c.cc.Invoke(ctx, PluginRegistry_CreatePlugin_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pluginRegistryClient) CreatePluginVersion(ctx context.Context, in *CreatePluginVersionRequest, opts ...grpc.CallOption) (*PluginVersion, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(PluginVersion)
	err := c.cc.Invoke(ctx, PluginRegistry_CreatePluginVersion_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pluginRegistryClient) CreatePluginPlatform(ctx context.Context, in *CreatePluginPlatformRequest, opts ...grpc.CallOption) (*PluginPlatform, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(PluginPlatform)
	err := c.cc.Invoke(ctx, PluginRegistry_CreatePluginPlatform_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pluginRegistryClient) UpdatePlugin(ctx context.Context, in *UpdatePluginRequest, opts ...grpc.CallOption) (*Plugin, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(Plugin)
	err := c.cc.Invoke(ctx, PluginRegistry_UpdatePlugin_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pluginRegistryClient) UploadPluginVersionDocFile(ctx context.Context, opts ...grpc.CallOption) (grpc.ClientStreamingClient[UploadPluginVersionDocFileRequest, emptypb.Empty], error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	stream, err := c.cc.NewStream(ctx, &PluginRegistry_ServiceDesc.Streams[0], PluginRegistry_UploadPluginVersionDocFile_FullMethodName, cOpts...)
	if err != nil {
		return nil, err
	}
	x := &grpc.GenericClientStream[UploadPluginVersionDocFileRequest, emptypb.Empty]{ClientStream: stream}
	return x, nil
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type PluginRegistry_UploadPluginVersionDocFileClient = grpc.ClientStreamingClient[UploadPluginVersionDocFileRequest, emptypb.Empty]

func (c *pluginRegistryClient) UploadPluginVersionReadme(ctx context.Context, opts ...grpc.CallOption) (grpc.ClientStreamingClient[UploadPluginVersionReadmeRequest, emptypb.Empty], error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	stream, err := c.cc.NewStream(ctx, &PluginRegistry_ServiceDesc.Streams[1], PluginRegistry_UploadPluginVersionReadme_FullMethodName, cOpts...)
	if err != nil {
		return nil, err
	}
	x := &grpc.GenericClientStream[UploadPluginVersionReadmeRequest, emptypb.Empty]{ClientStream: stream}
	return x, nil
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type PluginRegistry_UploadPluginVersionReadmeClient = grpc.ClientStreamingClient[UploadPluginVersionReadmeRequest, emptypb.Empty]

func (c *pluginRegistryClient) UploadPluginVersionSchema(ctx context.Context, opts ...grpc.CallOption) (grpc.ClientStreamingClient[UploadPluginVersionSchemaRequest, emptypb.Empty], error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	stream, err := c.cc.NewStream(ctx, &PluginRegistry_ServiceDesc.Streams[2], PluginRegistry_UploadPluginVersionSchema_FullMethodName, cOpts...)
	if err != nil {
		return nil, err
	}
	x := &grpc.GenericClientStream[UploadPluginVersionSchemaRequest, emptypb.Empty]{ClientStream: stream}
	return x, nil
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type PluginRegistry_UploadPluginVersionSchemaClient = grpc.ClientStreamingClient[UploadPluginVersionSchemaRequest, emptypb.Empty]

func (c *pluginRegistryClient) UploadPluginVersionShaSums(ctx context.Context, opts ...grpc.CallOption) (grpc.ClientStreamingClient[UploadPluginVersionShaSumsRequest, emptypb.Empty], error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	stream, err := c.cc.NewStream(ctx, &PluginRegistry_ServiceDesc.Streams[3], PluginRegistry_UploadPluginVersionShaSums_FullMethodName, cOpts...)
	if err != nil {
		return nil, err
	}
	x := &grpc.GenericClientStream[UploadPluginVersionShaSumsRequest, emptypb.Empty]{ClientStream: stream}
	return x, nil
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type PluginRegistry_UploadPluginVersionShaSumsClient = grpc.ClientStreamingClient[UploadPluginVersionShaSumsRequest, emptypb.Empty]

func (c *pluginRegistryClient) UploadPluginPlatformBinary(ctx context.Context, opts ...grpc.CallOption) (grpc.ClientStreamingClient[UploadPluginPlatformBinaryRequest, emptypb.Empty], error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	stream, err := c.cc.NewStream(ctx, &PluginRegistry_ServiceDesc.Streams[4], PluginRegistry_UploadPluginPlatformBinary_FullMethodName, cOpts...)
	if err != nil {
		return nil, err
	}
	x := &grpc.GenericClientStream[UploadPluginPlatformBinaryRequest, emptypb.Empty]{ClientStream: stream}
	return x, nil
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type PluginRegistry_UploadPluginPlatformBinaryClient = grpc.ClientStreamingClient[UploadPluginPlatformBinaryRequest, emptypb.Empty]

func (c *pluginRegistryClient) DeletePlugin(ctx context.Context, in *DeletePluginRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, PluginRegistry_DeletePlugin_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pluginRegistryClient) DeletePluginVersion(ctx context.Context, in *DeletePluginVersionRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, PluginRegistry_DeletePluginVersion_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *pluginRegistryClient) DeletePluginPlatform(ctx context.Context, in *DeletePluginPlatformRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, PluginRegistry_DeletePluginPlatform_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// PluginRegistryServer is the server API for PluginRegistry service.
// All implementations must embed UnimplementedPluginRegistryServer
// for forward compatibility.
//
// PluginRegistry is the service that provides methods to manage plugins.
type PluginRegistryServer interface {
	// GetPluginByID returns a plugin by its ID.
	GetPluginByID(context.Context, *GetPluginByIdRequest) (*Plugin, error)
	// GetPlugins returns a paginated list of plugins.
	GetPlugins(context.Context, *GetPluginsRequest) (*GetPluginsResponse, error)
	// GetPluginVersionByID returns a plugin version by its ID.
	GetPluginVersionByID(context.Context, *GetPluginVersionByIdRequest) (*PluginVersion, error)
	// GetPluginVersions returns a list of plugin versions.
	GetPluginVersions(context.Context, *GetPluginVersionsRequest) (*GetPluginVersionsResponse, error)
	// GetPluginPlatformByID returns a plugin platform by its ID.
	GetPluginPlatformByID(context.Context, *GetPluginPlatformByIdRequest) (*PluginPlatform, error)
	// GetPluginPlatforms returns a list of plugin platforms.
	GetPluginPlatforms(context.Context, *GetPluginPlatformsRequest) (*GetPluginPlatformsResponse, error)
	// CreatePlugin creates a new plugin.
	CreatePlugin(context.Context, *CreatePluginRequest) (*Plugin, error)
	// CreatePluginVersion creates a new plugin version.
	CreatePluginVersion(context.Context, *CreatePluginVersionRequest) (*PluginVersion, error)
	// CreatePluginPlatform creates a new plugin platform.
	CreatePluginPlatform(context.Context, *CreatePluginPlatformRequest) (*PluginPlatform, error)
	// UpdatePlugin updates a plugin.
	UpdatePlugin(context.Context, *UpdatePluginRequest) (*Plugin, error)
	UploadPluginVersionDocFile(grpc.ClientStreamingServer[UploadPluginVersionDocFileRequest, emptypb.Empty]) error
	// UploadPluginVersionReadme uploads a readme for a plugin version.
	UploadPluginVersionReadme(grpc.ClientStreamingServer[UploadPluginVersionReadmeRequest, emptypb.Empty]) error
	UploadPluginVersionSchema(grpc.ClientStreamingServer[UploadPluginVersionSchemaRequest, emptypb.Empty]) error
	// UploadPluginVersionShaSums uploads SHA sums for a plugin version.
	UploadPluginVersionShaSums(grpc.ClientStreamingServer[UploadPluginVersionShaSumsRequest, emptypb.Empty]) error
	// UploadPluginPlatformBinary uploads a plugin platform binary.
	UploadPluginPlatformBinary(grpc.ClientStreamingServer[UploadPluginPlatformBinaryRequest, emptypb.Empty]) error
	// DeletePlugin deletes a plugin.
	DeletePlugin(context.Context, *DeletePluginRequest) (*emptypb.Empty, error)
	// DeletePluginVersion deletes a plugin version by its ID.
	DeletePluginVersion(context.Context, *DeletePluginVersionRequest) (*emptypb.Empty, error)
	// DeletePluginPlatform deletes a plugin platform by its ID.
	DeletePluginPlatform(context.Context, *DeletePluginPlatformRequest) (*emptypb.Empty, error)
	mustEmbedUnimplementedPluginRegistryServer()
}

// UnimplementedPluginRegistryServer must be embedded to have
// forward compatible implementations.
//
// NOTE: this should be embedded by value instead of pointer to avoid a nil
// pointer dereference when methods are called.
type UnimplementedPluginRegistryServer struct{}

func (UnimplementedPluginRegistryServer) GetPluginByID(context.Context, *GetPluginByIdRequest) (*Plugin, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetPluginByID not implemented")
}
func (UnimplementedPluginRegistryServer) GetPlugins(context.Context, *GetPluginsRequest) (*GetPluginsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetPlugins not implemented")
}
func (UnimplementedPluginRegistryServer) GetPluginVersionByID(context.Context, *GetPluginVersionByIdRequest) (*PluginVersion, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetPluginVersionByID not implemented")
}
func (UnimplementedPluginRegistryServer) GetPluginVersions(context.Context, *GetPluginVersionsRequest) (*GetPluginVersionsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetPluginVersions not implemented")
}
func (UnimplementedPluginRegistryServer) GetPluginPlatformByID(context.Context, *GetPluginPlatformByIdRequest) (*PluginPlatform, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetPluginPlatformByID not implemented")
}
func (UnimplementedPluginRegistryServer) GetPluginPlatforms(context.Context, *GetPluginPlatformsRequest) (*GetPluginPlatformsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetPluginPlatforms not implemented")
}
func (UnimplementedPluginRegistryServer) CreatePlugin(context.Context, *CreatePluginRequest) (*Plugin, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreatePlugin not implemented")
}
func (UnimplementedPluginRegistryServer) CreatePluginVersion(context.Context, *CreatePluginVersionRequest) (*PluginVersion, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreatePluginVersion not implemented")
}
func (UnimplementedPluginRegistryServer) CreatePluginPlatform(context.Context, *CreatePluginPlatformRequest) (*PluginPlatform, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreatePluginPlatform not implemented")
}
func (UnimplementedPluginRegistryServer) UpdatePlugin(context.Context, *UpdatePluginRequest) (*Plugin, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdatePlugin not implemented")
}
func (UnimplementedPluginRegistryServer) UploadPluginVersionDocFile(grpc.ClientStreamingServer[UploadPluginVersionDocFileRequest, emptypb.Empty]) error {
	return status.Errorf(codes.Unimplemented, "method UploadPluginVersionDocFile not implemented")
}
func (UnimplementedPluginRegistryServer) UploadPluginVersionReadme(grpc.ClientStreamingServer[UploadPluginVersionReadmeRequest, emptypb.Empty]) error {
	return status.Errorf(codes.Unimplemented, "method UploadPluginVersionReadme not implemented")
}
func (UnimplementedPluginRegistryServer) UploadPluginVersionSchema(grpc.ClientStreamingServer[UploadPluginVersionSchemaRequest, emptypb.Empty]) error {
	return status.Errorf(codes.Unimplemented, "method UploadPluginVersionSchema not implemented")
}
func (UnimplementedPluginRegistryServer) UploadPluginVersionShaSums(grpc.ClientStreamingServer[UploadPluginVersionShaSumsRequest, emptypb.Empty]) error {
	return status.Errorf(codes.Unimplemented, "method UploadPluginVersionShaSums not implemented")
}
func (UnimplementedPluginRegistryServer) UploadPluginPlatformBinary(grpc.ClientStreamingServer[UploadPluginPlatformBinaryRequest, emptypb.Empty]) error {
	return status.Errorf(codes.Unimplemented, "method UploadPluginPlatformBinary not implemented")
}
func (UnimplementedPluginRegistryServer) DeletePlugin(context.Context, *DeletePluginRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeletePlugin not implemented")
}
func (UnimplementedPluginRegistryServer) DeletePluginVersion(context.Context, *DeletePluginVersionRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeletePluginVersion not implemented")
}
func (UnimplementedPluginRegistryServer) DeletePluginPlatform(context.Context, *DeletePluginPlatformRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeletePluginPlatform not implemented")
}
func (UnimplementedPluginRegistryServer) mustEmbedUnimplementedPluginRegistryServer() {}
func (UnimplementedPluginRegistryServer) testEmbeddedByValue()                        {}

// UnsafePluginRegistryServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to PluginRegistryServer will
// result in compilation errors.
type UnsafePluginRegistryServer interface {
	mustEmbedUnimplementedPluginRegistryServer()
}

func RegisterPluginRegistryServer(s grpc.ServiceRegistrar, srv PluginRegistryServer) {
	// If the following call pancis, it indicates UnimplementedPluginRegistryServer was
	// embedded by pointer and is nil.  This will cause panics if an
	// unimplemented method is ever invoked, so we test this at initialization
	// time to prevent it from happening at runtime later due to I/O.
	if t, ok := srv.(interface{ testEmbeddedByValue() }); ok {
		t.testEmbeddedByValue()
	}
	s.RegisterService(&PluginRegistry_ServiceDesc, srv)
}

func _PluginRegistry_GetPluginByID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetPluginByIdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PluginRegistryServer).GetPluginByID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: PluginRegistry_GetPluginByID_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PluginRegistryServer).GetPluginByID(ctx, req.(*GetPluginByIdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _PluginRegistry_GetPlugins_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetPluginsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PluginRegistryServer).GetPlugins(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: PluginRegistry_GetPlugins_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PluginRegistryServer).GetPlugins(ctx, req.(*GetPluginsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _PluginRegistry_GetPluginVersionByID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetPluginVersionByIdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PluginRegistryServer).GetPluginVersionByID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: PluginRegistry_GetPluginVersionByID_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PluginRegistryServer).GetPluginVersionByID(ctx, req.(*GetPluginVersionByIdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _PluginRegistry_GetPluginVersions_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetPluginVersionsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PluginRegistryServer).GetPluginVersions(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: PluginRegistry_GetPluginVersions_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PluginRegistryServer).GetPluginVersions(ctx, req.(*GetPluginVersionsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _PluginRegistry_GetPluginPlatformByID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetPluginPlatformByIdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PluginRegistryServer).GetPluginPlatformByID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: PluginRegistry_GetPluginPlatformByID_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PluginRegistryServer).GetPluginPlatformByID(ctx, req.(*GetPluginPlatformByIdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _PluginRegistry_GetPluginPlatforms_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetPluginPlatformsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PluginRegistryServer).GetPluginPlatforms(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: PluginRegistry_GetPluginPlatforms_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PluginRegistryServer).GetPluginPlatforms(ctx, req.(*GetPluginPlatformsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _PluginRegistry_CreatePlugin_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreatePluginRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PluginRegistryServer).CreatePlugin(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: PluginRegistry_CreatePlugin_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PluginRegistryServer).CreatePlugin(ctx, req.(*CreatePluginRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _PluginRegistry_CreatePluginVersion_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreatePluginVersionRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PluginRegistryServer).CreatePluginVersion(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: PluginRegistry_CreatePluginVersion_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PluginRegistryServer).CreatePluginVersion(ctx, req.(*CreatePluginVersionRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _PluginRegistry_CreatePluginPlatform_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreatePluginPlatformRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PluginRegistryServer).CreatePluginPlatform(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: PluginRegistry_CreatePluginPlatform_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PluginRegistryServer).CreatePluginPlatform(ctx, req.(*CreatePluginPlatformRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _PluginRegistry_UpdatePlugin_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdatePluginRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PluginRegistryServer).UpdatePlugin(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: PluginRegistry_UpdatePlugin_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PluginRegistryServer).UpdatePlugin(ctx, req.(*UpdatePluginRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _PluginRegistry_UploadPluginVersionDocFile_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(PluginRegistryServer).UploadPluginVersionDocFile(&grpc.GenericServerStream[UploadPluginVersionDocFileRequest, emptypb.Empty]{ServerStream: stream})
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type PluginRegistry_UploadPluginVersionDocFileServer = grpc.ClientStreamingServer[UploadPluginVersionDocFileRequest, emptypb.Empty]

func _PluginRegistry_UploadPluginVersionReadme_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(PluginRegistryServer).UploadPluginVersionReadme(&grpc.GenericServerStream[UploadPluginVersionReadmeRequest, emptypb.Empty]{ServerStream: stream})
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type PluginRegistry_UploadPluginVersionReadmeServer = grpc.ClientStreamingServer[UploadPluginVersionReadmeRequest, emptypb.Empty]

func _PluginRegistry_UploadPluginVersionSchema_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(PluginRegistryServer).UploadPluginVersionSchema(&grpc.GenericServerStream[UploadPluginVersionSchemaRequest, emptypb.Empty]{ServerStream: stream})
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type PluginRegistry_UploadPluginVersionSchemaServer = grpc.ClientStreamingServer[UploadPluginVersionSchemaRequest, emptypb.Empty]

func _PluginRegistry_UploadPluginVersionShaSums_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(PluginRegistryServer).UploadPluginVersionShaSums(&grpc.GenericServerStream[UploadPluginVersionShaSumsRequest, emptypb.Empty]{ServerStream: stream})
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type PluginRegistry_UploadPluginVersionShaSumsServer = grpc.ClientStreamingServer[UploadPluginVersionShaSumsRequest, emptypb.Empty]

func _PluginRegistry_UploadPluginPlatformBinary_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(PluginRegistryServer).UploadPluginPlatformBinary(&grpc.GenericServerStream[UploadPluginPlatformBinaryRequest, emptypb.Empty]{ServerStream: stream})
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type PluginRegistry_UploadPluginPlatformBinaryServer = grpc.ClientStreamingServer[UploadPluginPlatformBinaryRequest, emptypb.Empty]

func _PluginRegistry_DeletePlugin_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeletePluginRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PluginRegistryServer).DeletePlugin(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: PluginRegistry_DeletePlugin_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PluginRegistryServer).DeletePlugin(ctx, req.(*DeletePluginRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _PluginRegistry_DeletePluginVersion_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeletePluginVersionRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PluginRegistryServer).DeletePluginVersion(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: PluginRegistry_DeletePluginVersion_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PluginRegistryServer).DeletePluginVersion(ctx, req.(*DeletePluginVersionRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _PluginRegistry_DeletePluginPlatform_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeletePluginPlatformRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PluginRegistryServer).DeletePluginPlatform(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: PluginRegistry_DeletePluginPlatform_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PluginRegistryServer).DeletePluginPlatform(ctx, req.(*DeletePluginPlatformRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// PluginRegistry_ServiceDesc is the grpc.ServiceDesc for PluginRegistry service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var PluginRegistry_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "martiancloud.phobos.api.pluginregistry.PluginRegistry",
	HandlerType: (*PluginRegistryServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetPluginByID",
			Handler:    _PluginRegistry_GetPluginByID_Handler,
		},
		{
			MethodName: "GetPlugins",
			Handler:    _PluginRegistry_GetPlugins_Handler,
		},
		{
			MethodName: "GetPluginVersionByID",
			Handler:    _PluginRegistry_GetPluginVersionByID_Handler,
		},
		{
			MethodName: "GetPluginVersions",
			Handler:    _PluginRegistry_GetPluginVersions_Handler,
		},
		{
			MethodName: "GetPluginPlatformByID",
			Handler:    _PluginRegistry_GetPluginPlatformByID_Handler,
		},
		{
			MethodName: "GetPluginPlatforms",
			Handler:    _PluginRegistry_GetPluginPlatforms_Handler,
		},
		{
			MethodName: "CreatePlugin",
			Handler:    _PluginRegistry_CreatePlugin_Handler,
		},
		{
			MethodName: "CreatePluginVersion",
			Handler:    _PluginRegistry_CreatePluginVersion_Handler,
		},
		{
			MethodName: "CreatePluginPlatform",
			Handler:    _PluginRegistry_CreatePluginPlatform_Handler,
		},
		{
			MethodName: "UpdatePlugin",
			Handler:    _PluginRegistry_UpdatePlugin_Handler,
		},
		{
			MethodName: "DeletePlugin",
			Handler:    _PluginRegistry_DeletePlugin_Handler,
		},
		{
			MethodName: "DeletePluginVersion",
			Handler:    _PluginRegistry_DeletePluginVersion_Handler,
		},
		{
			MethodName: "DeletePluginPlatform",
			Handler:    _PluginRegistry_DeletePluginPlatform_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "UploadPluginVersionDocFile",
			Handler:       _PluginRegistry_UploadPluginVersionDocFile_Handler,
			ClientStreams: true,
		},
		{
			StreamName:    "UploadPluginVersionReadme",
			Handler:       _PluginRegistry_UploadPluginVersionReadme_Handler,
			ClientStreams: true,
		},
		{
			StreamName:    "UploadPluginVersionSchema",
			Handler:       _PluginRegistry_UploadPluginVersionSchema_Handler,
			ClientStreams: true,
		},
		{
			StreamName:    "UploadPluginVersionShaSums",
			Handler:       _PluginRegistry_UploadPluginVersionShaSums_Handler,
			ClientStreams: true,
		},
		{
			StreamName:    "UploadPluginPlatformBinary",
			Handler:       _PluginRegistry_UploadPluginPlatformBinary_Handler,
			ClientStreams: true,
		},
	},
	Metadata: "plugin_registry.proto",
}
